// Code generated by counterfeiter. DO NOT EDIT.
package smtpserverfakes

import (
	"sync"

	"gitlab.com/hackandsla.sh/letterbox/internal/smtpserver/dkim"
)

type FakeDkimChecker struct {
	GetStatusStub        func([]byte) (dkim.Status, error)
	getStatusMutex       sync.RWMutex
	getStatusArgsForCall []struct {
		arg1 []byte
	}
	getStatusReturns struct {
		result1 dkim.Status
		result2 error
	}
	getStatusReturnsOnCall map[int]struct {
		result1 dkim.Status
		result2 error
	}
	ValidateAlignmentStub        func([]byte, string) (bool, error)
	validateAlignmentMutex       sync.RWMutex
	validateAlignmentArgsForCall []struct {
		arg1 []byte
		arg2 string
	}
	validateAlignmentReturns struct {
		result1 bool
		result2 error
	}
	validateAlignmentReturnsOnCall map[int]struct {
		result1 bool
		result2 error
	}
	invocations      map[string][][]interface{}
	invocationsMutex sync.RWMutex
}

func (fake *FakeDkimChecker) GetStatus(arg1 []byte) (dkim.Status, error) {
	var arg1Copy []byte
	if arg1 != nil {
		arg1Copy = make([]byte, len(arg1))
		copy(arg1Copy, arg1)
	}
	fake.getStatusMutex.Lock()
	ret, specificReturn := fake.getStatusReturnsOnCall[len(fake.getStatusArgsForCall)]
	fake.getStatusArgsForCall = append(fake.getStatusArgsForCall, struct {
		arg1 []byte
	}{arg1Copy})
	stub := fake.GetStatusStub
	fakeReturns := fake.getStatusReturns
	fake.recordInvocation("GetStatus", []interface{}{arg1Copy})
	fake.getStatusMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeDkimChecker) GetStatusCallCount() int {
	fake.getStatusMutex.RLock()
	defer fake.getStatusMutex.RUnlock()
	return len(fake.getStatusArgsForCall)
}

func (fake *FakeDkimChecker) GetStatusCalls(stub func([]byte) (dkim.Status, error)) {
	fake.getStatusMutex.Lock()
	defer fake.getStatusMutex.Unlock()
	fake.GetStatusStub = stub
}

func (fake *FakeDkimChecker) GetStatusArgsForCall(i int) []byte {
	fake.getStatusMutex.RLock()
	defer fake.getStatusMutex.RUnlock()
	argsForCall := fake.getStatusArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeDkimChecker) GetStatusReturns(result1 dkim.Status, result2 error) {
	fake.getStatusMutex.Lock()
	defer fake.getStatusMutex.Unlock()
	fake.GetStatusStub = nil
	fake.getStatusReturns = struct {
		result1 dkim.Status
		result2 error
	}{result1, result2}
}

func (fake *FakeDkimChecker) GetStatusReturnsOnCall(i int, result1 dkim.Status, result2 error) {
	fake.getStatusMutex.Lock()
	defer fake.getStatusMutex.Unlock()
	fake.GetStatusStub = nil
	if fake.getStatusReturnsOnCall == nil {
		fake.getStatusReturnsOnCall = make(map[int]struct {
			result1 dkim.Status
			result2 error
		})
	}
	fake.getStatusReturnsOnCall[i] = struct {
		result1 dkim.Status
		result2 error
	}{result1, result2}
}

func (fake *FakeDkimChecker) ValidateAlignment(arg1 []byte, arg2 string) (bool, error) {
	var arg1Copy []byte
	if arg1 != nil {
		arg1Copy = make([]byte, len(arg1))
		copy(arg1Copy, arg1)
	}
	fake.validateAlignmentMutex.Lock()
	ret, specificReturn := fake.validateAlignmentReturnsOnCall[len(fake.validateAlignmentArgsForCall)]
	fake.validateAlignmentArgsForCall = append(fake.validateAlignmentArgsForCall, struct {
		arg1 []byte
		arg2 string
	}{arg1Copy, arg2})
	stub := fake.ValidateAlignmentStub
	fakeReturns := fake.validateAlignmentReturns
	fake.recordInvocation("ValidateAlignment", []interface{}{arg1Copy, arg2})
	fake.validateAlignmentMutex.Unlock()
	if stub != nil {
		return stub(arg1, arg2)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeDkimChecker) ValidateAlignmentCallCount() int {
	fake.validateAlignmentMutex.RLock()
	defer fake.validateAlignmentMutex.RUnlock()
	return len(fake.validateAlignmentArgsForCall)
}

func (fake *FakeDkimChecker) ValidateAlignmentCalls(stub func([]byte, string) (bool, error)) {
	fake.validateAlignmentMutex.Lock()
	defer fake.validateAlignmentMutex.Unlock()
	fake.ValidateAlignmentStub = stub
}

func (fake *FakeDkimChecker) ValidateAlignmentArgsForCall(i int) ([]byte, string) {
	fake.validateAlignmentMutex.RLock()
	defer fake.validateAlignmentMutex.RUnlock()
	argsForCall := fake.validateAlignmentArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2
}

func (fake *FakeDkimChecker) ValidateAlignmentReturns(result1 bool, result2 error) {
	fake.validateAlignmentMutex.Lock()
	defer fake.validateAlignmentMutex.Unlock()
	fake.ValidateAlignmentStub = nil
	fake.validateAlignmentReturns = struct {
		result1 bool
		result2 error
	}{result1, result2}
}

func (fake *FakeDkimChecker) ValidateAlignmentReturnsOnCall(i int, result1 bool, result2 error) {
	fake.validateAlignmentMutex.Lock()
	defer fake.validateAlignmentMutex.Unlock()
	fake.ValidateAlignmentStub = nil
	if fake.validateAlignmentReturnsOnCall == nil {
		fake.validateAlignmentReturnsOnCall = make(map[int]struct {
			result1 bool
			result2 error
		})
	}
	fake.validateAlignmentReturnsOnCall[i] = struct {
		result1 bool
		result2 error
	}{result1, result2}
}

func (fake *FakeDkimChecker) Invocations() map[string][][]interface{} {
	fake.invocationsMutex.RLock()
	defer fake.invocationsMutex.RUnlock()
	fake.getStatusMutex.RLock()
	defer fake.getStatusMutex.RUnlock()
	fake.validateAlignmentMutex.RLock()
	defer fake.validateAlignmentMutex.RUnlock()
	copiedInvocations := map[string][][]interface{}{}
	for key, value := range fake.invocations {
		copiedInvocations[key] = value
	}
	return copiedInvocations
}

func (fake *FakeDkimChecker) recordInvocation(key string, args []interface{}) {
	fake.invocationsMutex.Lock()
	defer fake.invocationsMutex.Unlock()
	if fake.invocations == nil {
		fake.invocations = map[string][][]interface{}{}
	}
	if fake.invocations[key] == nil {
		fake.invocations[key] = [][]interface{}{}
	}
	fake.invocations[key] = append(fake.invocations[key], args)
}
